searchNodes=[{"doc":"PhxComponentHelpers are helper functions meant to be used within Phoenix LiveView live_components to make your components more configurable and extensible from your templates.It provides following features:set html attributes from component assignsset data attributes from component assignsset phx_* attributes from component assignsencode attributes as JSON from an Elixir structure assignvalidate mandatory attributesset and extend css classes from component assigns","ref":"PhxComponentHelpers.html","title":"PhxComponentHelpers","type":"module"},{"doc":"Extends assigns with class attributes.The class attribute will take provided default_classes as a default value and will be extended, on a class-by-class basis, by your assigns.Parametersassigns - your component assignsclass_attribute_name - the class attribute you want to define, :class by defaultdefault_classes - the css classed that will put by defaultExampleassigns |&gt; extend_class(&quot;bg-blue-500 mt-8&quot;) |&gt; extend_class(:wrapper_class, &quot;py-4 px-2 divide-y-8 divide-gray-200&quot;)assigns now contains @html_class and @html_wrapper_class.If your input assigns were %{class: &quot;mt-2&quot;, wrapper_class: &quot;divide-none&quot;} then:@html_class would contain &quot;bg-blue-500 mt-2&quot;@html_wrapper_class would contain &quot;py-4 px-2 divide-none&quot;","ref":"PhxComponentHelpers.html#extend_class/3","title":"PhxComponentHelpers.extend_class/3","type":"function"},{"doc":"Extends assigns with html_* attributes that can be interpolated within your component markup.Parametersassigns - your component assignsattributes - a list of attributes (atoms) that will be fetched from assignsOptions:init - a list of attributes that will be initialized if absent from assigns:required - raises if required attributes are absent from assigns:json - when true, will JSON encode the assign valueExampleassigns |&gt; set_component_attributes([:id, :name, :label], required: [:id, :name]) |&gt; set_component_attributes([:value], json: true)assigns now contains @html_id, @html_name, @html_label and @html_value.","ref":"PhxComponentHelpers.html#set_component_attributes/3","title":"PhxComponentHelpers.set_component_attributes/3","type":"function"},{"doc":"Extends assigns with html_* data-attributes that can be interpolated within your component markup.Behaves exactly like set_component_attributes/3 excepted the output @html_attr assigns contain data-attributes markup.Exampleassigns |&gt; set_data_attributes([:key, :text], required: [:key]) |&gt; set_data_attributes([:document], json: true)assigns now contains @html_key, @html_text and @html_document.","ref":"PhxComponentHelpers.html#set_data_attributes/3","title":"PhxComponentHelpers.set_data_attributes/3","type":"function"},{"doc":"Extends assigns with phx* attributes that can be interpolated within your component markup. It will automatically detect any attribute prefixed by phx_ from input assigns.Parametersassigns - your component assignsOptions:init - a list of attributes that will be initialized if absent from assigns:required - raises if required attributes are absent from assignsExampleassigns |&gt; set_phx_attributes([:phx_change, :phx_submit], required: [:phx_submit], init: [:phx_change])assigns now contains @html_phx_change and @html_phx_submit.","ref":"PhxComponentHelpers.html#set_phx_attributes/2","title":"PhxComponentHelpers.set_phx_attributes/2","type":"function"},{"doc":"PhxComponentHelpers","ref":"readme.html","title":"PhxComponentHelpers","type":"extras"},{"doc":"PhxComponentHelpers are helper functions meant to be used within Phoenix LiveView live_components to make your components more configurable and extensible from your templates.It provides the following features:set HTML attributes from component assignsset data attributes from component assignsset phx_* attributes from component assignsencode attributes as JSON from an Elixir structure assignvalidate mandatory attributesset and extend CSS classes from component assigns","ref":"readme.html#presentation","title":"PhxComponentHelpers - Presentation","type":"extras"},{"doc":"PhxComponentHelpers allows you to write components as such:defmodule Forms.Button do use Phoenix.LiveComponent import PhxComponentHelpers def mount(socket), do: {:ok, socket} def update(assigns, socket) do assigns = assigns |&gt; extend_class(&quot;bg-blue-700 hover:bg-blue-900 ...&quot;) |&gt; set_component_attributes([:type, :id, :label], required: [:label]) |&gt; set_phx_attributes() {:ok, assign(socket, assigns)} end def render(assigns) do ~L&quot;&quot;&quot; &lt;button &lt;%= @html_id %&gt; &lt;%= @html_type %&gt; &lt;%= @html_phx_click %&gt; &lt;%= @html_class %&gt;&gt; &lt;%= @label %&gt; &lt;/button&gt; &quot;&quot;&quot; end endFrom your templates, it's looking like this:&lt;%= live_component @socket, Form, id: &quot;form&quot;, phx_submit: &quot;form_submit&quot;, class: &quot;divide-none&quot; do %&gt; &lt;%= live_component @socket, InputGroup do %&gt; &lt;%= live_component @socket, Label, for: &quot;name&quot;, label: &quot;Name&quot; %&gt; &lt;%= live_component @socket, TextInput, name: &quot;name&quot;, value: @my.name %&gt; &lt;% end %&gt; &lt;%= live_component @socket, ButtonGroup, class: &quot;pt-2&quot; do %&gt; &lt;%= live_component @socket, Button, type: &quot;submit&quot;, phx_click: &quot;btn-click&quot;, label: &quot;Save&quot; %&gt; &lt;% end %&gt; &lt;% end %&gt;","ref":"readme.html#example","title":"PhxComponentHelpers - Example","type":"extras"},{"doc":"Surface is a library built on the top of Phoenix LiveView and live_components. Surface is much more ambitious, heavier, and complex than PhxComponentHelpers is (which obviously isn't a framework, just helpers ...).Surface really changes the way you code user interfaces and components (you almost won't be using HTML templates anymore) whereas PhxComponentHelpers are just some sugar to help you using raw phoenix_live_view.","ref":"readme.html#compared-to-surface","title":"PhxComponentHelpers - Compared to Surface","type":"extras"},{"doc":"Available on https://hexdocs.pm","ref":"readme.html#documentation","title":"PhxComponentHelpers - Documentation","type":"extras"},{"doc":"Add the following to your mix.exs.def deps do [ {:phx_component_helpers, &quot;~&gt; 0.2.0&quot;}, {:jason, &quot;~&gt; 1.0&quot;} # only required if you want to use json encoding options ] end","ref":"readme.html#installation","title":"PhxComponentHelpers - Installation","type":"extras"}]